Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis1.inc
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis1.inc	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis1.inc	(revision 1038)
@@ -6,8 +6,15 @@
 
        CALL inifis(ngridmx,nlayer,         &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                &
                wappel_phys,                     &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis2.inc
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis2.inc	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis2.inc	(revision 1038)
@@ -9,8 +9,15 @@
        CASE(1)
        CALL inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                &
                wappel_phys,                     &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -29,8 +36,15 @@
        CASE(2)
        CALL d2_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis3.inc
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis3.inc	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis3.inc	(revision 1038)
@@ -9,8 +9,15 @@
        CASE(1)
        CALL inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                &
                wappel_phys,                     &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -28,8 +35,15 @@
        CASE(2)
        CALL d2_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -47,8 +61,15 @@
        CASE(3)
        CALL d3_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis4.inc
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis4.inc	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/call_meso_inifis4.inc	(revision 1038)
@@ -9,8 +9,15 @@
        CASE(1)
        CALL inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                &
                wappel_phys,                     &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -28,8 +35,15 @@
        CASE(2)
        CALL d2_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -47,8 +61,15 @@
        CASE(3)
        CALL d3_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
@@ -66,8 +87,15 @@
        CASE(4)
        CALL d4_inifis(ngridmx,nlayer, &
+#ifdef NEWPHYS
+               nq,  &
+#endif
                wday_ini,wdaysec,                   &
                wappel_phys,                        &
                lat_vec,lon_vec,aire_vec,1/reradius,g,r_d,cp,           &
-               nqmx,dt,                                                &
+#ifdef NEWPHYS
+               dt,                                                     &
+#else
+               nq,dt,                                                &
+#endif
                womeg,wmugaz,                                           &
                wyear_day,wperiheli,waphelie,wperi_day,wobliquit,       &
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm	(revision 1038)
@@ -514,5 +514,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-makdim $ntrac $dim
+makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm.last
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm.last	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm.last	(revision 1038)
@@ -518,5 +518,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-makdim $ntrac $dim
+makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95	(revision 1038)
@@ -531,5 +531,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95.last
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95.last	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_g95.last	(revision 1038)
@@ -517,5 +517,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-makdim $ntrac $dim
+makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_ifort
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_ifort	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_ifort	(revision 1038)
@@ -519,5 +519,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpi
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpi	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpi	(revision 1038)
@@ -531,5 +531,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-makdim $ntrac $dim
+makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpifort
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpifort	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_mpifort	(revision 1038)
@@ -519,5 +519,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-./makdim $ntrac $dim
+./makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_pgf
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_pgf	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd_new/makegcm_pgf	(revision 1038)
@@ -523,5 +523,5 @@
 # Build the appropriate 'dimensions.h' file
 cd dimension
-makdim $ntrac $dim
+makdim $dim
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F	(revision 856)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F	(revision 1038)
@@ -192,5 +192,5 @@
    ! *** for LMD physics
    ! ------> inputs:
-   INTEGER :: ngrid,nlayer,nq,nsoil,nqmx 
+   INTEGER :: ngrid,nlayer,nq,nsoil 
    REAL :: pday,ptime,MY  
    REAL :: aire_val,lat_val,lon_val
@@ -391,10 +391,8 @@
 nlayer = kpe-kps+1                    ! number of vertical layers: nlayermx
 nsoil = NUM_SOIL_LAYERS               ! number of soil layers: nsoilmx
-if (num_3d_s > 1) then                ! number of advected fields: nqmx
+if (num_3d_s > 1) then                ! number of advected fields
         nq = num_3d_s-1               
-        nqmx = num_3d_s-1
 else
         nq = 1
-        nqmx = 1
 endif
 ! **** needed but hardcoded
@@ -1052,5 +1050,5 @@
     qsurf_val(2)=MARS_WICE(i,j)    !! logique avec wtnom(2) = 'h2o_ice' defini ci-dessus
                                    !! ----- retrocompatible ancienne physique
-                                   !! ----- [H2O ice is tracer nqmx in qsurf in LMD physics]
+                                   !! ----- [H2O ice is last tracer in qsurf in LMD physics]
     CASE(2)  
     qsurf_val(1)=0.                !! not coupled with lifting for the moment [non remobilise]