Index: /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/plot_sounding.py
===================================================================
--- /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/plot_sounding.py	(revision 1051)
+++ /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/plot_sounding.py	(revision 1051)
@@ -0,0 +1,27 @@
+#! /usr/bin/env python
+import ppplot
+import numpy as np
+
+# load data
+# http://docs.scipy.org/doc/numpy/reference/generated/numpy.loadtxt.html
+p,z,t,dew,hum,mix,wdir,wknot,thta,thte,thtv \
+    = np.loadtxt("sounding.txt",skiprows=8,unpack=True)
+
+# make a simple plot
+sdg = ppplot.plot1d()
+sdg.f = z
+sdg.x = t
+sdg.makeshow()
+
+# Tweaking a little bit the plot
+sdg.linestyle = '-'
+sdg.marker = '.'
+sdg.color = 'r'
+sdg.ycoeff = 1.e-3
+sdg.title = "A random terrestrial sounding"
+sdg.legend = "Fort Smith 00Z 26 Sep 2013"
+sdg.xlabel = "Temperature ($^{\circ}$C)"
+sdg.ylabel = "Altitude (km)"
+sdg.makeshow()
+
+
Index: /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/sounding.txt
===================================================================
--- /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/sounding.txt	(revision 1051)
+++ /trunk/UTIL/PYTHON/planetoplot_v2/examples/scripts_ppplot_only/sounding.txt	(revision 1051)
@@ -0,0 +1,137 @@
+
+71934 YSM Fort Smith Observations at 00Z 26 Sep 2013
+
+-----------------------------------------------------------------------------
+   PRES   HGHT   TEMP   DWPT   RELH   MIXR   DRCT   SKNT   THTA   THTE   THTV
+    hPa     m      C      C      %    g/kg    deg   knot     K      K      K 
+-----------------------------------------------------------------------------
+ 1000.0    124                                                               
+  990.0    203   10.6    7.1     79   6.43    330      3  284.6  302.7  285.7
+  978.0    305    9.7    6.6     81   6.29    340      9  284.6  302.4  285.7
+  942.8    610    6.9    5.2     89   5.90    345     13  284.8  301.4  285.8
+  925.0    769    5.4    4.4     93   5.70    350     14  284.8  301.0  285.8
+  913.0    876    4.6    4.0     96   5.61    346     14  285.1  301.0  286.0
+  908.7    914    4.4    3.8     96   5.56    345     14  285.2  301.0  286.2
+  875.1   1219    2.5    2.3     98   5.18    355     13  286.4  301.2  287.3
+  852.0   1436    1.2    1.2    100   4.92      9      8  287.2  301.4  288.1
+  850.0   1455    1.4    1.3     99   4.97     10      8  287.6  301.9  288.5
+  843.0   1522    2.8    1.5     91   5.09     34     10  289.8  304.5  290.6
+  842.8   1524    2.8    1.4     91   5.07     35     10  289.8  304.5  290.6
+  819.0   1755    2.0   -4.0     64   3.49     20     13  291.3  301.7  291.9
+  811.6   1829    1.6   -3.7     68   3.60     15     14  291.6  302.3  292.2
+  793.0   2015    0.4   -3.0     78   3.88     15     15  292.3  303.9  293.0
+  787.0   2076    0.6   -6.4     59   3.02     15     15  293.1  302.3  293.7
+  781.3   2134    0.3   -7.4     56   2.82     15     15  293.4  302.0  293.9
+  753.0   2429   -1.5  -12.5     43   1.95     20     17  294.6  300.7  294.9
+  752.2   2438   -1.6  -12.5     43   1.96     20     17  294.6  300.7  295.0
+  723.7   2743   -3.9  -11.0     58   2.30     20     17  295.3  302.5  295.7
+  700.0   3006   -5.9   -9.7     75   2.63     25     13  295.9  304.1  296.4
+  669.4   3353   -8.3  -10.9     82   2.50     30     10  297.0  304.8  297.5
+  655.0   3523   -9.5  -11.5     85   2.43      5     11  297.5  305.1  298.0
+  643.6   3658  -10.3  -13.8     76   2.06    345     12  298.1  304.6  298.5
+  638.0   3725  -10.7  -14.9     71   1.89    347     11  298.4  304.4  298.8
+  594.1   4267  -15.6  -16.4     93   1.79      0      5  298.9  304.6  299.2
+  586.0   4371  -16.5  -16.7     98   1.78    351      5  299.0  304.7  299.3
+  570.0   4579  -17.1  -17.8     94   1.66    332      5  300.7  306.0  301.0
+  567.0   4618  -17.7  -20.2     81   1.36    328      5  300.4  304.9  300.7
+  562.0   4684  -17.5  -25.5     50   0.86    322      5  301.4  304.3  301.6
+  559.0   4724  -17.5  -20.2     79   1.38    319      5  301.9  306.4  302.1
+  550.0   4846  -17.9  -18.7     93   1.60    308      5  302.8  308.0  303.1
+  547.7   4877  -18.1  -19.2     91   1.54    305      5  302.9  307.9  303.2
+  542.0   4955  -18.7  -20.4     86   1.40    310      6  303.1  307.7  303.4
+  539.0   4996  -19.1  -25.1     59   0.93    313      7  303.1  306.3  303.3
+  532.0   5093  -19.7  -26.7     54   0.81    319      9  303.5  306.3  303.7
+  525.6   5182  -20.4  -26.8     57   0.82    325     10  303.7  306.5  303.9
+  504.0   5492  -22.9  -27.1     68   0.83    333      6  304.4  307.2  304.5
+  500.0   5550  -23.5  -27.7     68   0.79    335      5  304.3  307.0  304.5
+  463.5   6096  -27.5  -31.2     71   0.62    335      6  306.1  308.2  306.2
+  416.0   6874  -33.1  -36.1     74   0.42    335      3  308.4  309.9  308.5
+  408.0   7010  -33.7  -37.0     72   0.39    335      2  309.4  310.8  309.4
+  400.0   7150  -34.3  -38.0     69   0.36     30      7  310.3  311.7  310.4
+  373.5   7620  -37.5  -40.7     72   0.29     70     18  312.2  313.3  312.2
+  341.8   8230  -41.7  -44.3     76   0.22    100     19  314.5  315.3  314.6
+  325.0   8576  -44.1  -46.3     79   0.19    102     23  315.8  316.5  315.8
+  300.0   9110  -47.5  -50.7     69   0.12    105     30  318.3  318.8  318.3
+  298.4   9144  -47.8  -51.1     69   0.12    105     30  318.4  318.9  318.4
+  283.0   9492  -50.3  -54.7     60   0.08    114     36  319.6  320.0  319.6
+  271.8   9754  -51.8  -55.2     67   0.08    120     41  321.1  321.5  321.2
+  264.0   9941  -52.9  -55.6     72   0.08    120     38  322.2  322.6  322.2
+  256.0  10138  -53.9  -59.9     48   0.05    120     34  323.6  323.8  323.6
+  250.0  10290  -53.7  -66.7     19   0.02    120     24  326.1  326.2  326.1
+  249.0  10316  -53.7  -67.7     16   0.02    120     23  326.5  326.6  326.5
+  247.2  10363  -53.4  -68.3     14   0.02    120     21  327.6  327.7  327.6
+  236.0  10668  -51.3  -72.4      6   0.01     95     10  335.2  335.2  335.2
+  225.2  10973  -49.2  -76.5      3   0.01    100     11  342.9  342.9  342.9
+  219.0  11157  -47.9  -78.9      2   0.00     88     10  347.6  347.6  347.6
+  215.0  11278  -47.7  -79.7      1   0.00     80     10  349.7  349.8  349.7
+  205.4  11582  -47.2  -81.6      1   0.00     95     11  355.1  355.1  355.1
+  203.0  11661  -47.1  -82.1      1   0.00     97     10  356.5  356.5  356.5
+  200.0  11760  -47.5  -82.5      1   0.00    100      9  357.4  357.4  357.4
+  174.0  12678  -48.5  -82.5      1   0.00    135     11  370.2  370.3  370.2
+  170.8  12802  -47.4  -82.2      1   0.00    140     11  374.1  374.1  374.1
+  170.0  12831  -47.1  -82.1      1   0.00    142     11  375.0  375.1  375.0
+  164.0  13069  -47.9  -81.9      1   0.00    162     12  377.6  377.6  377.6
+  163.1  13106  -47.6  -81.8      1   0.00    165     12  378.7  378.7  378.7
+  160.0  13232  -46.5  -81.5      1   0.00     97      7  382.6  382.6  382.6
+  155.7  13411  -46.5  -81.5      1   0.00      0      1  385.6  385.6  385.6
+  150.0  13660  -46.5  -81.5      1   0.00    245      4  389.7  389.8  389.7
+  149.0  13704  -46.3  -81.3      1   0.00    238      4  390.8  390.8  390.8
+  135.6  14326  -48.3  -82.7      1   0.00    145      1  397.9  397.9  397.9
+  127.0  14758  -49.7  -83.7      1   0.00    190      6  402.9  402.9  402.9
+  123.6  14935  -49.9  -83.9      1   0.00    160     10  405.7  405.8  405.7
+  118.0  15240  -50.2  -84.2      1   0.00    175     11  410.6  410.6  410.6
+  113.0  15521  -50.5  -84.5      1   0.00    129     12  415.1  415.1  415.1
+  112.6  15545  -50.4  -84.4      1   0.00    125     12  415.8  415.8  415.8
+  108.0  15817  -48.9  -82.9      1   0.00    147     13  423.5  423.6  423.5
+  107.5  15850  -49.0  -83.0      1   0.00    150     13  423.9  423.9  423.9
+  102.6  16154  -50.2  -84.2      1   0.00    215      7  427.3  427.3  427.3
+  100.0  16320  -50.9  -84.9      1   0.00    215      7  429.1  429.1  429.1
+   92.3  16839  -52.7  -85.7      1   0.00    286      4  435.5  435.5  435.5
+   90.1  16995  -51.5  -84.5      1   0.00    308      3  440.9  440.9  440.9
+   86.3  17274  -52.5  -85.5      1   0.00    346      2  444.3  444.4  444.3
+   85.0  17374  -51.3  -85.2      1   0.00      0      1  448.8  448.8  448.8
+   84.8  17388  -51.1  -85.1      1   0.00      0      1  449.4  449.4  449.4
+   70.4  18593  -52.5  -85.5      1   0.00      0      1  471.0  471.1  471.0
+   70.0  18630  -52.5  -85.5      1   0.00    230      1  471.7  471.7  471.7
+   64.0  19202  -53.1  -85.8      1   0.00      0      1  482.6  482.6  482.6
+   58.2  19812  -53.7  -86.2      1   0.00    215      1  494.5  494.5  494.5
+   50.0  20790  -54.7  -86.7      1   0.00     70      5  514.1  514.2  514.1
+   48.1  21031  -54.8  -86.8      1   0.00    170     10  519.5  519.5  519.5
+   45.9  21336  -54.9  -86.9      1   0.00    175     12  526.4  526.4  526.4
+   43.8  21641  -55.0  -87.0      1   0.00    220     11  533.3  533.4  533.3
+   39.8  22250  -55.2  -87.2      1   0.00    280     14  547.5  547.5  547.5
+   37.9  22555  -55.4  -87.3      1   0.01     30      1  554.8  554.8  554.8
+   34.5  23165  -55.6  -87.6      1   0.01    220     14  569.5  569.6  569.5
+   31.3  23774  -55.8  -87.8      1   0.01    270     11  584.7  584.7  584.7
+   30.0  24050  -55.9  -87.9      1   0.01    215      6  591.6  591.7  591.7
+   23.5  25603  -57.7  -89.7      1   0.01    200     10  629.3  629.3  629.3
+   23.5  25599  -57.7  -89.7      1   0.01    200     10  629.1  629.2  629.1
+   22.4  25908  -57.4  -89.4      1   0.01    235     10  638.9  639.0  638.9
+   21.3  26213  -57.1  -89.1      1   0.01    160      2  648.6  648.7  648.6
+   20.3  26518  -56.8  -88.8      1   0.01    230     10  658.5  658.6  658.5
+   20.0  26620  -56.7  -88.7      1   0.01    235     11  661.9  662.0  661.9
+   18.5  27127  -55.5  -88.0      1   0.01    225     13  680.9  681.0  680.9
+   17.6  27432  -54.8  -87.7      1   0.01    225     10  692.5  692.6  692.5
+   17.3  27545  -54.5  -87.5      1   0.01    242     13  696.9  697.0  696.9
+   16.8  27737  -55.0  -87.7      1   0.01    270     19  701.4  701.5  701.4
+   16.0  28042  -55.7  -88.1      1   0.01    210     10  708.6  708.8  708.6
+   15.3  28346  -56.4  -88.5      1   0.01    275     18  715.9  716.0  715.9
+   15.2  28371  -56.5  -88.5      1   0.01    272     18  716.5  716.6  716.5
+   14.6  28651  -54.4  -87.1      1   0.01    240     22  732.8  732.9  732.8
+   14.3  28761  -53.5  -86.5      1   0.02    260     20  739.2  739.4  739.2
+   13.9  28956  -54.5  -86.9      1   0.02    295     17  742.5  742.6  742.5
+   13.5  29130  -55.3  -87.3      1   0.01    289     16  745.3  745.5  745.3
+   13.2  29261  -55.0  -87.1      1   0.02    285     15  750.9  751.0  750.9
+   12.0  29870  -53.3  -86.1      1   0.02    310     12  777.1  777.4  777.1
+   11.5  30175  -52.5  -85.6      1   0.02    270     15  790.6  790.9  790.6
+   11.0  30480  -51.7  -85.1      1   0.03    260     17  804.3  804.6  804.3
+   10.4  30785  -50.9  -84.6      1   0.03    215     17  818.2  818.6  818.2
+   10.0  31090  -49.9  -84.0      1   0.03    250     17  832.8  833.3  832.8
+   10.0  31070  -50.1  -84.1      1   0.03    250     18  831.4  831.9  831.5
+    9.3  31548  -45.9  -80.9      1   0.06    246     26  864.8  865.6  864.9
+    9.1  31699  -45.7  -80.8      1   0.06    245     29  871.2  872.0  871.2
+    8.7  32004  -45.3  -80.5      1   0.07    235     26  884.2  885.2  884.3
+    8.3  32309  -44.9  -80.3      1   0.08    265     23  897.5  898.5  897.5
+    7.9  32614  -44.4  -80.0      1   0.08    250     25  910.9  912.0  910.9
+    7.6  32918  -44.0  -79.8      1   0.09    260     41  924.5  925.7  924.5
+    7.0  33450  -43.3  -79.3      1   0.11    270     36  948.7  950.2  948.8