Index: trunk/UTIL/PYTHON/planetoplot_v2/examples/ppclass_additional/archean.sh
===================================================================
--- trunk/UTIL/PYTHON/planetoplot_v2/examples/ppclass_additional/archean.sh	(revision 1054)
+++ trunk/UTIL/PYTHON/planetoplot_v2/examples/ppclass_additional/archean.sh	(revision 1054)
@@ -0,0 +1,65 @@
+#! /usr/bin/env python
+import ppclass
+import numpy as np
+
+asr = ppclass.pp()
+asr.file = "diagfi115.nc"
+asr.var = "ASR"
+asr.t = 360
+asr.get()
+
+isr = ppclass.pp()
+isr << asr
+isr.var = "ISR"
+isr.get()
+
+tau = ppclass.pp()
+tau << asr
+tau.var = "tau_col"
+tau.get()
+
+alb = ppclass.pp()
+alb << asr
+alb.var = "ALB"
+alb.get()
+
+tsurf = ppclass.pp()
+tsurf << asr
+tsurf.var = "tsurf"
+add = tsurf.getf()
+
+
+
+##alb.smooth(20)
+#tau.smooth(2)
+
+
+#albedo = asr/isr
+##albedo = 1.-albedo
+#albedo = albedo + taucol
+
+albedo = alb + tau/100.
+
+albedo.colorb = "Blues_r"
+albedo.div = 20 #10
+#albedo.vmin = 0.3
+#albedo.vmax = 0.7
+albedo.proj = "ortho"
+
+
+albedo.defineplot()
+albedo.p[0].blat = 15.
+albedo.p[0].showcb = False
+albedo.p[0].title = ""
+
+albedo.p[0].addcontour = add - 273.15
+
+#dafield = albedo.p[0].field
+#dafield[np.where(dafield < 0.4)] = 0.0
+#dafield[np.where(dafield > 0.6)] = 1.0
+albedo.p[0].vmin = 0.1
+albedo.p[0].vmax = 0.6
+
+#albedo.p[0].back = "coast"
+
+albedo.makeplot()
Index: trunk/UTIL/PYTHON/planetoplot_v2/pp.py
===================================================================
--- trunk/UTIL/PYTHON/planetoplot_v2/pp.py	(revision 1052)
+++ trunk/UTIL/PYTHON/planetoplot_v2/pp.py	(revision 1054)
@@ -71,4 +71,5 @@
 parser.add_option('-V','--void',action='store_true',dest='void',default=False,help="no colorbar, no title, no labels")
 parser.add_option('-U','--units',action='append',dest='units',type="string",default=None,help="units for the field")
+parser.add_option('-F','--fmt',action='append',dest='fmt',type="string",default=None,help="values formatting. ex: '%.0f' '%3.1e'")
 # -- 1D plot
 parser.add_option('-L','--linestyle',action='append',dest='linestyle',type="string",default=None,help="[1D] linestyle: '-' '--' '.' '..'")
Index: trunk/UTIL/PYTHON/planetoplot_v2/ppclass.py
===================================================================
--- trunk/UTIL/PYTHON/planetoplot_v2/ppclass.py	(revision 1052)
+++ trunk/UTIL/PYTHON/planetoplot_v2/ppclass.py	(revision 1054)
@@ -56,4 +56,10 @@
         except: pass
         print output ; output = ""
+
+# request a given attribute (and test if it is here)
+def ncattr(filename,char):
+    nc = netCDF4.Dataset(filename)
+    if hasattr(nc,char): ncattr=getattr(nc,char)
+    return ncattr
 
 # check a tab and exit if wrong. if just one string make it a list.
@@ -164,4 +170,5 @@
                       savtxt=False,\
                       modx=None,\
+                      fmt=None,\
                       xp=16,yp=8,\
                       missing=1.e25,\
@@ -223,4 +230,5 @@
         self.xp = xp ; self.yp = yp
         self.nxticks = nxticks ; self.nyticks = nyticks
+        self.fmt = fmt
 
     # print status
@@ -282,4 +290,5 @@
             self.missing = other.missing
             self.nxticks = other.nxticks ; self.nyticks = other.nyticks
+            self.fmt = other.fmt
         else:
             print "!! ERROR !! argument must be a pp object." ; exit()
@@ -825,4 +834,5 @@
                     if self.nxticks is not None: plobj.nxticks = self.nxticks
                     if self.nyticks is not None: plobj.nyticks = self.nyticks
+                    if self.fmt is not None: plobj.fmt = self.fmt
                     # -- 1D specific
                     if dp == 1:
@@ -1210,4 +1220,9 @@
             except:
                 try: self.p[iii].modx = opt.modx[0]
+                except: pass
+            ###
+            try: self.p[iii].fmt = opt.fmt[iii]
+            except:
+                try: self.p[iii].fmt = opt.fmt[0]
                 except: pass
 
Index: trunk/UTIL/PYTHON/planetoplot_v2/ppplot.py
===================================================================
--- trunk/UTIL/PYTHON/planetoplot_v2/ppplot.py	(revision 1052)
+++ trunk/UTIL/PYTHON/planetoplot_v2/ppplot.py	(revision 1054)
@@ -815,5 +815,5 @@
                 objC2 = m.contour(x, y, what_I_contour, \
                             zelevelsc, colors = ccol, linewidths = cline)
-                #mpl.clabel(objC2, inline=1, fontsize=10)
+                #mpl.clabel(objC2, inline=1, fontsize=10,manual=True,fmt='-%2.0f$^{\circ}$C',colors='r')
             m.contourf(x, y, what_I_plot, zelevels, cmap = palette, alpha = self.trans)
         ############################################################################################